#ifndef __APPTOOLS_H__
#define __APPTOOLS_H__

// ******************************************************************
// ****** Timer Functions *******************************************
// ******************************************************************

void StartTimer(unsigned long Duration);
void StopTimer(void);
bool TestTimer(void);

// ******************************************************************
// ****** Host Communication ****************************************
// ******************************************************************

void WriteChar(char Char);
void WriteString(const char *String);
void WriteRadix(const byte *ID,int BitCnt,int DigitCnt,int Radix);
void WriteBin(const byte *ID,int BitCnt,int DigitCnt);
void WriteDec(const byte *ID,int BitCnt,int DigitCnt);
void WriteHex(const byte *ID,int BitCnt,int DigitCnt);
void WriteVersion(void);

// ******************************************************************
// ****** Beep Functions ********************************************
// ******************************************************************

void SetVolume(int NewVolume);
int GetVolume(void);
void BeepLow(void);
void BeepHigh(void);

// ******************************************************************
// ****** Compatibility to TWN3 *************************************
// ******************************************************************

int ConvertTagTypeToTWN3(int TagTypeTWN4);

#endif