#define APP_MAGIC			0x49A31CF1

#ifndef VERSION
  #define VERSION 0x0000
#endif
#ifndef APPCHARS
  #define APPCHARS APP
#endif

typedef struct __attribute__((__packed__))
{
	unsigned long	Magic;
	unsigned long	Crc;
	unsigned long	Stack;
	unsigned long	ResetHandler;
	unsigned short	DeviceType;
	char            AppChars[4];
	unsigned short  AppVersion;
} TAppHeader;

// Data defined by the linker script
extern unsigned long _stext;
extern unsigned long _etext;
extern unsigned long _sdata;
extern unsigned long _edata;
extern unsigned long _sbss;
extern unsigned long _ebss;
extern unsigned long _estack;

void ResetHandler(void);
int main(void);

#define STR_VALUE(arg)	STR_VALUE2(arg) 
#define STR_VALUE2(arg)	#arg 

__attribute__ ((section(".header"), used))
const TAppHeader AppHeader = 
	{ APP_MAGIC, 0xFFFFFFFF, (unsigned long)&_estack, (unsigned long)ResetHandler, 128, STR_VALUE(APPCHARS), VERSION };

void ResetHandler (void)
{
	unsigned long *pSrc;
   	unsigned long *pDest;
   
   	pSrc  = &_etext;
   	pDest = &_sdata;
   	while(pDest < &_edata)
      	*pDest++ = *pSrc++;
   
   	pDest = &_sbss;
   	while(pDest < &_ebss)
      	*pDest++ = 0;

   	main();
   	
   	while (1)
   		;
}
